﻿using System.Collections.Generic;
using System.IO;
using System.Net.Http;
using Bsm.Core.Models.Raw;
using Newtonsoft.Json;

namespace Bsm.Core.Loader
{
    public class PpListLoader
    {
        public static Dictionary<string, PpListModel> FromWeb()
        {
            var json = new HttpClient(new HttpClientHandler
            {
                AutomaticDecompression = System.Net.DecompressionMethods.GZip | System.Net.DecompressionMethods.Deflate
            }).GetAsync("https://cdn.wes.cloud/beatstar/bssb/v2-all.json").Result.Content.ReadAsStringAsync().Result;
            return JsonConvert.DeserializeObject<Dictionary<string, PpListModel>>(json);
        }

        public static Dictionary<string, PpListModel> FromFile(string path)
        {
            var json = File.ReadAllText(path);
            return JsonConvert.DeserializeObject<Dictionary<string, PpListModel>>(json);
        }
    }
}
